#include<bits/stdc++.h>

using namespace std;
const int maxn= 114514;//栈大小
int st[maxn];//栈
int st_l,st_top;//栈底和栈头
int block_sz = 0;
inline int find_page(int x){//在栈里查找并且返回坐标
  if(st_l==st_top)return -1;
  for(int i=st_l;i<st_top;++i){
    if(st[i]==x)return i;
  }
  return -1;
}
inline int get_size(){//获得目前栈的大小
  return st_top-st_l;
}
inline int add_page(int x){//添加页
  if(st_top==maxn-1) return -1;
  if(get_size()<block_sz){//如果还有空间就直接添加
    st[st_top++]=x;
    return 1;
  }
  int out_page=st[st_l];//没有空间了，删掉栈底的，我觉得这更像个队列
  st_l++;
  st[st_top++]=x;//扔到栈顶。
  return 2;
}
inline void move_to_top(int x){//把最新找到的元素放到栈顶，标记已经用过
    int idx=find_page(x);
    if(idx==-1){return;}//没有找到元素
    //将找到的页面移到栈顶
    //从找到的位置开始，将页面往前移，直到栈顶
    for(int i=idx;i<st_top-1;++i){
      st[i]=st[i+1];
    }
    st[st_top-1]=x; // 将页面放置于栈顶
}

inline void init(){
  st_l = 0;//默认栈底不存东东
  st_top = 0;
}

inline void print_st(){
  printf("  栈信息:");
  for(int i=st_l;i<st_top;++i){
    printf("%d ",st[i]);
  }
  printf("\n");
  // printf("\n===============\n");
}


int works[maxn];
int cnt_works;

inline int solve_rd(){
  cout<<"请输入存储区块数：";
  cin>>block_sz;
  cout<<"\n[info]存储区块数:"<<block_sz<<"\n";

  //读入作业
  int x;
  cout<<"请输入作业的页面走向（输入0结束）：\n";
  while(1){
    cout<<"页面号"<< cnt_works <<":";
    cin>>x;
    
    if(!x){cout<<"输入结束！\n";break;}
    works[++cnt_works]=x;
    cout<<works[cnt_works-1]<<"\n";
  }

  return 1;
}

inline int solve_doit(){
  cout<<"置换情况如下：\n";
  int interrupt_cnt = 0;//缺页中断计数
  for(int i=1;i<=cnt_works;++i){
    // print_st();
    int wk = works[i];
    int idx=find_page(wk);//查询是否在栈中

    printf("[debug]新作业页面:%d\n",wk);

    if(idx==-1){//不在栈中
      ++interrupt_cnt;//中断计数器+1
      int res = add_page(wk);
      // int out_page = add_page(wk);
      if(res==1){
        cout<<"\e[32m[info-int]发生中断，但内存中有空闲区，"<<wk<<"号页面直接调入！\e[0m\n";
      }
      if(res==2){
        int out_page = st[st_l-1];
        cout<<"\e[32m[info-int]发生中断，将"<<out_page<<"号页面调出，"<<wk<<"号装入！\e[0m\n";
      }

    }else{//栈里有这个
      cout<<"\e[32m[info]内存中有"<<wk<<"号页面，无须中断！\n\e[0m";
    }
    // print_st();
    move_to_top(wk);//移动到最顶上
  }
  double int_p = (1.0)*(interrupt_cnt)/cnt_works*100.0;
  cout<<"\e[34m【结果】作业："<<cnt_works<<" 个，中断 "<<interrupt_cnt<<" 次，缺页率："<<fixed<<setprecision(4)<< int_p<<"%\e[0m\n";
  return 1;
}


int main(){
  clock_t start = clock();
  freopen("4_big.in","r",stdin);

  init();
  solve_rd();
  solve_doit();

  clock_t end = clock();
  double duration = 1.00*(end - start) / CLOCKS_PER_SEC;
  cout<<fixed<<setprecision(6)<<"程序运行时间:"<<duration<<"秒\n";
}