#include <bits/stdc++.h>

using namespace std;
const int maxn = 114514;  // 最大页面数
int block_sz = 0;

unordered_map<int, list<int>::iterator> mp;  // 使用 unordered_map 存储页面号和对应的 list 迭代器
list<int> lru_list;  // 使用 list 存储页面的访问顺序

inline int find_page(int x) {
    return mp.count(x);
}

inline int get_size() {
    return mp.size();
}

inline void add_page(int x) {
    if (get_size() == block_sz) {
        int out_page = lru_list.back();
        lru_list.pop_back();
        mp.erase(out_page);
    }
    lru_list.push_front(x);
    mp[x] = lru_list.begin();
}

inline void update_page(int x) {
    lru_list.erase(mp[x]);
    lru_list.push_front(x);
    mp[x] = lru_list.begin();
}

int works[maxn];
int cnt_works;

inline int solve_rd() {
    cout << "请输入存储区块数：";
    cin >> block_sz;
    cout << "\n[info]存储区块数:" << block_sz << "\n";

    // 读入作业
    int x;
    cout << "请输入作业的页面走向（输入0结束）：\n";
    while (1) {
        cout << "页面号" << cnt_works << ":";
        cin >> x;

        if (!x) {
            cout << "输入结束！\n";
            break;
        }
        works[++cnt_works] = x;
        cout << works[cnt_works - 1] << "\n";
    }

    return 1;
}

inline int solve_doit() {
    cout << "置换情况如下：\n";
    int interrupt_cnt = 0;  // 缺页中断计数
    for (int i = 1; i <= cnt_works; ++i) {
        int wk = works[i];
        int idx = find_page(wk);

        printf("[debug]新作业页面:%d\n", wk);

        if (!idx) {
            ++interrupt_cnt;
            add_page(wk);
            if (get_size() <= block_sz) {
                cout << "\e[32m[info-int]发生中断，但内存中有空闲区，" << wk << "号页面直接调入！\e[0m\n";
            } else {
                int out_page = lru_list.back();
                cout << "\e[32m[info-int]发生中断，将" << out_page << "号页面调出，" << wk << "号装入！\e[0m\n";
            }
        } else {
            cout << "\e[32m[info]内存中有" << wk << "号页面，无须中断！\n\e[0m";
            update_page(wk);
        }
    }
    double int_p = (1.0) * (interrupt_cnt) / cnt_works * 100.0;
    cout << "\e[34m【结果】作业：" << cnt_works << " 个，中断 " << interrupt_cnt << " 次，缺页率："
         << fixed << setprecision(4) << int_p << "%\e[0m\n";
    return 1;
}

int main() {
    clock_t start = clock();
    freopen("4_big.in", "r", stdin);

    solve_rd();
    solve_doit();

    clock_t end = clock();
    double duration = 1.00 * (end - start) / CLOCKS_PER_SEC;
    cout << fixed << setprecision(6) << "程序运行时间:" << duration << "秒\n";
}