#include <stdio.h>
#include <sys/wait.h>
#include <unistd.h>

int main() {
  pid_t pid_a, pid_b, pid_c, pid_d;
  int st;

  pid_a=getpid();//获取父进程A的进程ID

  // 创建子进程B
  pid_b = fork();
  if (pid_b < 0) {
    fprintf(stderr, "Fork B Failed");
    return 1;
  }
  if (pid_b == 0) {//B进程
    printf("[info-B] Process B! PID=%d PPID=%d\n", getpid(), getppid());
    // 在子进程B中创建子进程D
    pid_d = fork();
    if (pid_d < 0) {
      fprintf(stderr, "Fork D Failed");
      return 1;
    }
    if (pid_d == 0) {
      printf("[info-D] Process D! PID=%d PPID=%d\n", getpid(), getppid());
    }
    if (pid_d > 0) {
      printf("[info-B] Waiting for D PID=%d... \n", pid_d);
      wait(&st);
      printf("[info-B] D exited with code:%d~,D PID=%d... \n", st,pid_d);
    }
    return 0;
  }
  // 在父进程A中创建子进程C
  pid_c = fork();
  if (pid_c < 0) {
    fprintf(stderr, "Fork Failed");
    return 1;
  }
  if(pid_c == 0){//子进程C
    printf("[info-C] Process C! PID=%d PPID=%d\n", getpid(), getppid());
    return 0;
  }
  if (pid_a == getpid()) {
    printf("[info-A] Process A! PID=%d PPID=%d\n", getpid(), getppid());
    printf("[info-A] Waiting for B PID=%d... \n", pid_b);
    wait(&st); // 等待子进程B结束
    printf("[info-A] B exited with code:%d~,B PID=%d... \n", st,pid_b);

    printf("[info-A] Waiting for C PID=%d... \n", pid_c);
    wait(&st); // 等待子进程C结束
    printf("[info-A] C exited with code:%d~,C PID=%d... \n", st,pid_c);
  }

  return 0;
}