#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <error.h>
#include <wait.h>
#include <unistd.h>
#include <time.h>

inline void child_process(int pipefd, int child_num) {
  char outpipe[10];  // 减小写入的数据量
  usleep(rand() % 100000);  // 随机延迟0到100毫秒
  sprintf(outpipe, "Child %d: %d\n", child_num, getpid());
  write(pipefd, outpipe, 10);
  exit(0);
}

int main() {
  int fd[2];
  char inpipe[1024];  // 增大读取的缓冲区
  pipe(fd);
  srand(time(NULL));  // 初始化随机数种子

  int num_children = 50;  // 增加子进程的数量

  for (int i = 0; i < num_children; ++i) {
    pid_t pid = fork();
    if (pid == -1) {
      perror("fork");
      exit(1);
    } else if (pid == 0) {
      child_process(fd[1], i);
    }
  }

  // 父进程
  close(fd[1]);  // 关闭写端
  int bytes_read = 0;
  while ((bytes_read = read(fd[0], inpipe, 1024)) > 0) {
    write(STDOUT_FILENO, inpipe, bytes_read);  // 直接写到标准输出
  }

  for (int i = 0; i < num_children; ++i) {
    wait(NULL);
  }

  close(fd[0]);
  return 0;
}