#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <error.h>
#include <wait.h>
#include <unistd.h>

const int rd_sz = 8000;

inline void child_process(int pipefd, int child_num) {
  char outpipe[8192];
  
  
  printf("The Child process %d (PID: %d) is sending message!\n", child_num, getpid());
  lockf(pipefd, F_LOCK, 0);  // 互斥
  sprintf(outpipe, "This is the child %d process's message! (PID: %d)\n", child_num, getpid());
  // for(int i=10;i<=8000;++i)outpipe[i]=child_num%26+'a';
  // outpipe[8000]='\0';
  write(pipefd, outpipe,rd_sz);
  lockf(pipefd, F_ULOCK, 0);
  sleep(1);
  exit(0);
}

pid_t pids[123004];
const int maxn = 100;

int main() {
  int pid1, pid2, pid3;
  int fd[2];
  char inpipe[8192];
  pipe(fd);  // 创建一个管道
  perror("pipe");//返回前面一个函数的执行系统错误信息

  int fa_pid = getpid();

  pid1 = fork();
  if (pid1 == -1) {
    perror("fork");
    exit(1);
  } else if (pid1 == 0) {
    child_process(fd[1], 1);
  }

  pid2 = fork();
  if (pid2 == -1) {
    perror("fork");
    exit(1);
  } else if (pid2 == 0) {
    // 子进程p2
    child_process(fd[1], 2);
  }

  pid3 = fork();
  if (pid3 == -1) {
    perror("fork");
    exit(1);
  } else if (pid3 == 0) {
    // 子进程p3
    child_process(fd[1], 3);
  }


  //进程
  for(int i=5;i<=maxn;++i){
    pid_t tmp_pid = fork();
    if(tmp_pid == -1){
      perror("fork");
      exit(1);
    }
    if(tmp_pid==0){
      child_process(fd[1],i);
    }else{
      // write(fd[1], "ovovoovovovo",12);
    }
  }


  // 父进程
  // 等待子进程p1结束
  waitpid(pid1, NULL, 0);
  read(fd[0], inpipe, rd_sz);
  printf("\n[fa]fa proc rev from p1: %s", inpipe);
  // 等待子进程p2结束
  waitpid(pid2, NULL, 0);
  read(fd[0], inpipe, rd_sz);
  printf("[fa]fa proc rev from p2: %s", inpipe);
  // 等待子进程p3结束
  waitpid(pid3, NULL, 0);
  read(fd[0], inpipe, rd_sz);
  printf("[fa]fa proc rev from p3: %s", inpipe);

  for(int i=5;i<=maxn;++i){
    // wait(0);
    read(fd[0],inpipe,rd_sz);
    printf("[fa]%s",inpipe);
  }

  close(fd[0]);
  close(fd[1]);
  return 0;
}