#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <error.h>
#include <wait.h>
#include <unistd.h>
#include <string.h>

const int rd_sz = 4;

void child_process(int pipefd) {
  char message[] = "12345678";
  write(pipefd, message, strlen(message));
  exit(0);
}

int main() {
  int pid;
  int fd[2];
  char inpipe[5];
  pipe(fd);  // 创建一个管道
  perror("pipe");//返回前面一个函数的执行系统错误信息

  pid = fork();
  if (pid == -1) {
    perror("fork");
    exit(1);
  } else if (pid == 0) {
    close(fd[0]);  // 关闭读端
    child_process(fd[1]);
  } else {
    // 父进程A
    close(fd[1]);  // 关闭写端
    
    // 第一次读取4个字符
    read(fd[0], inpipe, rd_sz);
    inpipe[rd_sz] = '\0';  // 添加字符串结束符
    printf("Process A received (first 4 characters): %s\n", inpipe);
    
    // 第二次读取剩余的4个字符
    read(fd[0], inpipe, rd_sz);
    inpipe[rd_sz] = '\0';  // 添加字符串结束符
    printf("Process A received (last 4 characters): %s\n", inpipe);
    
    // 等待子进程B结束
    waitpid(pid, NULL, 0);
  }

  close(fd[0]);
  return 0;
}