#include<bits/stdc++.h>
using namespace std;

//宏定义进程状态
#define WAIT 0
#define RUNNING 1 
#define FINISH 2
#define IDLE 3

const int sleep_time = 20000; 

const int maxn = 114514;//最大PID

struct PCB {
  char name[23];//进程名
  int priority;//优先级
  int arrive_time;//到达时间
  int need_time;//所需运行时间
  int used_time;//已使用CPU时间
  int state;//进程状态
  int pid;//PID
  PCB():state(IDLE) {} //构造函数，默认这个进程装菜为IDLE，IDLE
  bool operator<(const PCB& other) const {//重载小于号，方便std优先队列排序
    if (priority != other.priority) {
      return priority < other.priority;
    }
    return arrive_time > other.arrive_time;//如果优先级相同用到达顺序排列
  }
}pcb[maxn];

int pcb_cnt = 0;
int now_time = 0;//到达时间模拟输出


//彩色输出和一些屏幕控制=======
const char COLOR_RED[]     = "\x1b[31m";
const char COLOR_GREEN[]   = "\x1b[32m";
const char COLOR_YELLOW[]  = "\x1b[33m";
const char COLOR_BLUE[]    = "\x1b[34m";
const char COLOR_MAGENTA[] = "\x1b[35m";
const char COLOR_CYAN[]    = "\x1b[36m";
const char COLOR_RESET[]   = "\x1b[0m";
const char COLOR_WHITE[] = "\x1b[37m";
const char COLOR_GRAY[] = "\x1b[90m";
inline void color_printf(const char* color, const char* format, ...);
inline void clear_screen();
//彩色输出=======

priority_queue<PCB> pq;//维护进程，大根堆。

inline void add_process(const char* name,int pri,int need) {
  now_time++;
  while(pcb[++pcb_cnt].state!=IDLE){//找一个空闲的PID
    pcb_cnt++;
  }
  strcpy(pcb[pcb_cnt].name,name);//复制字符串
  pcb[pcb_cnt].priority=pri;
  pcb[pcb_cnt].arrive_time=now_time;
  pcb[pcb_cnt].state=WAIT;//默认直接就绪状态
  pcb[pcb_cnt].need_time=need;//需要运行的时间
  pcb[pcb_cnt].pid=pcb_cnt;//PID
  color_printf(COLOR_GREEN, "[+]添加进程:[时间 %d] 添加进程 No.%d\n",now_time,pcb_cnt);
  color_printf(COLOR_GREEN, "[+]添加进程:[时间 %d] 添加进程 PID:%d\n",now_time,pcb[pcb_cnt].pid);
  color_printf(COLOR_GREEN, "[+]添加进程:进程名: %s\n",pcb[pcb_cnt].name);
  color_printf(COLOR_GREEN, "[+]添加进程:优先级: %d\n",pcb[pcb_cnt].priority);
  color_printf(COLOR_GREEN, "[+]添加进程:到达时间: %d\n",pcb[pcb_cnt].arrive_time);
  color_printf(COLOR_GREEN, "[+]添加进程:所需运行时间: %d\n",pcb[pcb_cnt].need_time);
  //维护进程优先级
  color_printf(COLOR_GREEN,"[+]添加进程:添加到队列中");
  pq.push(pcb[pcb_cnt]);
  if(pcb_cnt>=maxn-10){//防止越界，但这里处理的可能有点小问题，实际上
      pcb_cnt = 0;
  }
  color_printf(COLOR_BLUE,"\n[-]----------------------\n");
}


inline void print_pcb_info();
inline void print_pcb_info_2();
inline void print_ready();

int finish_time[maxn];
int finish_cnt = 0;

//pq是一个大根堆
inline void running() {
  clear_screen();
  if (!pq.empty()) {// 如果优先队列不为空,取出优先级最高的进程执行
    PCB current_process = pq.top();//拿出来
    pq.pop();//从堆中移除掉
    int idx=current_process.pid;//当前运行PID
    if (pcb[idx].state == WAIT) {
      pcb[idx].state = RUNNING;//改成运行模式

      color_printf(COLOR_MAGENTA,"[+]当前时间刻:%d\n",now_time);
      color_printf(COLOR_RED, "[R][时间 %d][RUNNING]当前运行进程 No.%d:\n", now_time, idx);
      color_printf(COLOR_RED, "[R][时间 %d][RUNNING]进程名: %s PID:%d\n",now_time,pcb[idx].name,pcb[idx].pid);
      pcb[idx].used_time++;//获得时间刻，模拟运行

      print_pcb_info_2();//打印PCB信息

      if (pcb[idx].used_time==pcb[idx].need_time) {//如果已经运行完成
        pcb[idx].state = FINISH;//标记为完成
        color_printf(COLOR_MAGENTA, "[R][RUNNING][时间 %d] 进程 %s 已完成.\n", now_time, pcb[idx].name);

        //记录完成顺序
        finish_time[idx]=++finish_cnt;
      }else{
        //目前未运行完成

        pcb[idx].priority--;//降低优先级
        pcb[idx].priority = max(0,pcb[idx].priority);//防止出现负数优先级
        pcb[idx].state=WAIT;//标记为就绪队列
        color_printf(COLOR_MAGENTA, "[R][RUNNING][时间 %d]进程 %s 时间片已用完，降低优先级，重新进入就绪队列.\n", now_time, pcb[idx].name);
        pq.push(pcb[idx]); 
      }
    }
  }
  print_ready();//输出就绪队列信息
  now_time++;
}



inline void add_process_(){
  
  

  add_process("process1",10,10);
  add_process("process2",20,15);  
  add_process("process3",30,30);


  //添加随机进程
  srand(time(0));
  int rd_int=rand()%20;
  for(int i=1;i<=rd_int;++i){
    char str_proc[23];
    sprintf(str_proc, "pc_rand_%d", i);
    int priority=rand() % 100;
    int arrive_time=rand() % 100;
    int need_time=rand() % 100;
    add_process(str_proc,priority,need_time);
  }

  printf("输入任意字符继续\n");
  getchar();
}



#ifdef _WIN32
#include<windows.h> 
#endif

inline void init(){
  pcb_cnt = 0;
  now_time = 0;
  add_process_();

  color_printf(COLOR_GREEN, "\n开始运行进程...\n");
  // 运行进程...  
  while(true){
    running();
    bool all_finish = true;
    for(int i=1;i<=pcb_cnt;i++){//暴力检查是否全部运行完成
      if(pcb[i].state!=FINISH){
        all_finish = false;
        break;
      }
    }
    if(all_finish){
      break;
    }

    #ifdef _WIN32
    Sleep(4);
    #else
    usleep(sleep_time); // 0.1
    #endif
  }
}

int main(){
  init();
  color_printf(COLOR_GREEN, "\n所有进程运行完毕.\n");
  
  print_pcb_info_2();
  return 0;
}



//彩色输出，无关紧要

inline void color_printf(const char* color, const char* format, ...) {
  va_list args;
  va_start(args, format);
  printf("%s", color);
  vprintf(format, args);
  printf("%s", COLOR_RESET);
  va_end(args);
}
inline void clear_screen(){
  #ifdef _WIN32
  system("cls");
  #else
  system("clear");
  #endif
}

//输出PCB等

inline void print_pcb_info_2() {
  color_printf(COLOR_BLUE, "[+][时间 %d]===============Taskmgr=============\n", now_time);
  color_printf(COLOR_GREEN, "[+][时间 %d]当前进程控制块(PCB)信息:\n", now_time);
  // color_printf(COLOR_BLUE, "[+][时间 %d]------------------------------------------\n", now_time);
  color_printf(COLOR_GREEN, "[+][时间 %d] PID    进程名     优先级    到达时间    所需运行时间    已用CPU时间    进程状态\n", now_time);
  for (int i = 1; i <= pcb_cnt; i++) {
    color_printf(COLOR_GREEN, "[+][时间 %d] %-6d %-10s %-9d %-12d %-15d %-13d ", now_time, i, pcb[i].name, pcb[i].priority, pcb[i].arrive_time, pcb[i].need_time, pcb[i].used_time);
    if (pcb[i].state == WAIT) {
      color_printf(COLOR_BLUE, "就绪(Wait)\n");
    } else if (pcb[i].state == RUNNING) {
      color_printf(COLOR_GREEN, "运行(Running)\n");  
    } else if (pcb[i].state == FINISH) {
      color_printf(COLOR_MAGENTA, "完成(Finish) 完成顺序:%d\n",finish_time[pcb[i].pid]);
    }
  }
  // color_printf(COLOR_BLUE, "[+][时间 %d]------------------------------------------\n", now_time);
  color_printf(COLOR_BLUE, "[+][时间 %d]===============Taskmgr=============\n", now_time);
}


inline void print_pcb_info() {
  color_printf(COLOR_BLUE, "[I][时间 %d][PCB-INFO]===============Taskmgr=============\n");
  color_printf(COLOR_GREEN, "[I][时间 %d][PCB-INFO][时间 %d] 当前进程控制块(PCB)信息:\n",now_time);
  for (int i = 1; i <= pcb_cnt; i++) {
    color_printf(COLOR_GREEN, "[-][PCB-INFO]进程 PID:%d:\n", i);
    color_printf(COLOR_GREEN, "[-][PCB-INFO] 进程名: %s\n", pcb[i].name);
    color_printf(COLOR_GREEN, "[-][PCB-INFO] 优先级: %d\n", pcb[i].priority);
    color_printf(COLOR_GREEN, "[-][PCB-INFO] 到达时间: %d\n", pcb[i].arrive_time);
    color_printf(COLOR_GREEN, "[-][PCB-INFO] 所需运行时间: %d\n", pcb[i].need_time);
    color_printf(COLOR_GREEN, "[-][PCB-INFO] 已用CPU时间: %d\n", pcb[i].used_time);
    color_printf(COLOR_GREEN, "[-][PCB-INFO] 进程状态: ");
    
    if (pcb[i].state == WAIT) {
      color_printf(COLOR_BLUE, "就绪(Wait)\n");
    }
    if (pcb[i].state == RUNNING) {
      color_printf(COLOR_GREEN, "运行(Running)\n");  
    }
    if (pcb[i].state == FINISH) {
        color_printf(COLOR_MAGENTA, "完成(Finish)\n");
    }
    color_printf(COLOR_YELLOW, "[-]---------------------\n");
  }
  color_printf(COLOR_BLUE, "[-][PCB-INFO]===============Taskmgr=============\n");
  //color_printf(COLOR_GREEN, "[-][PCB-INFO]===============Taskmgr=============\n");
}


inline void print_ready() {
    color_printf(COLOR_RESET,"\n");
    color_printf(COLOR_YELLOW, "[+][时间 %d]===========就绪队列信息===========\n", now_time);
    color_printf(COLOR_BLUE, "[+][时间 %d] 优先级  PID    进程名          到达时间    所需运行时间    已用CPU时间\n", now_time);
    
    std::priority_queue<PCB> temp_queue = pq;
    while (!temp_queue.empty()) {
        PCB process = temp_queue.top();
        temp_queue.pop();
        if (process.state == WAIT) {
            color_printf(COLOR_BLUE, "[+][时间 %d] %-8d %-6d %-14s %-11d %-14d %-12d\n", now_time, process.priority, process.pid, process.name, process.arrive_time, process.need_time, process.used_time);
        }
    }
    
    color_printf(COLOR_YELLOW, "[+][时间 %d]===========就绪队列信息===========\n", now_time);
}



