#include<bits/stdc++.h>
#include<algorithm>

const int pagesize = 4096;  // 页大小为4KB
const int pagetablelength = 64+1;  // 页表长度为64

using namespace std;
int pagetable[pagetablelength];
inline void generatePageTable(int length) {
  for(int i=1;i<=length;++i)pagetable[i] = i;
  srand(time(NULL));
  random_shuffle(pagetable+1,pagetable+length+1);
}

int main() {
  generatePageTable(64);//随机生成页表
  
  while(true) {
    // 打印页表
    printf("系统页号对应块号情况（页号——>块号）：\n");
    for(int i=1;i<=pagetablelength;++i){
      printf("%2d-->%2d ",i,pagetable[i]);
      if(i%8==0)printf("\n");
    }
    
    // 获取逻辑地址
    int logicaladdress;
    printf("\n请输入逻辑地址（十进制）：\n");
    scanf("%d", &logicaladdress);
    if(logicaladdress < 0) {
      printf("输入的逻辑地址无效，程序结束。\n");
      break;
    }
    
    // 计算物理地址
    int pagenum=logicaladdress/pagesize;  // 求页号
    int w=logicaladdress%pagesize;  // 求页内偏移地址
    if (pagenum>=pagetablelength) {  // 判断是否跃界
      printf("本次访问的地址已超出进程的地址空间，系统将产生越界中断！\n");
    } else {
      int addr = pagetable[pagenum] * pagesize + w;
      printf("对应的物理地址为（十进制）：%d\n",addr);
    }
    
    // 询问是否继续
    printf("\n是否继续查询？（Y/N）：");
    char choice;
    scanf(" %c", &choice);
    if(choice != 'Y' && choice != 'y') {
      printf("程序结束。\n");
      break;
    }
  }
  return 0;
}